<template>
  <div>
    <div>
      <el-form :inline="true" class="orderform" size="mini">
        <el-row>
          <el-form-item>
            <el-input v-model="tag" style="width: 250px" placeholder="请输入..." class="search_tag" clearable/>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="btn_search()"><i class="el-icon-search"/> 查询</el-button>
            <el-button @click="btn_clear()"><i class="el-icon-remove-outline"/> 重置</el-button>
            <!--el-button type="primary" icon="el-icon-plus" @click="addRole">添加</el-button-->
          </el-form-item>
        </el-row>
      </el-form>
      <el-table
        ref="multipleTable"
        :data="tableData"
        :highlight-current-row="true"
        border>
        <el-table-column
          prop="id"
          label="编号"/>
        <el-table-column
          prop="createTime"
          label="反馈时间"/>
        <el-table-column
          prop="userInfo.wechatName"
          label="反馈客户"/>
        <el-table-column
          prop="phone"
          label="联系电话"/>
        <el-table-column
          prop="email"
          label="邮箱地址"/>
        <el-table-column
          prop="content"
          label="反馈内容"/>
          <!--el-table-column
          fixed="right"
          label="操作">
          <template slot-scope="scope">
            <el-button v-if="scope.row.id !== 1 && scope.row.id !== 2" type="text" @click="editRole(scope.row)">编辑</el-button>
            <el-button v-if="scope.row.id !== 1 && scope.row.id !== 2" type="text" @click="deleteRoleConfirm(scope.row)">删除</el-button>
          </template>
        </el-table-column-->
      </el-table>
      <div class="mydiv">
        <el-pagination
          :current-page.sync="pageNo"
          :page-sizes="[10, 50, 100, 300,1000]"
          :page-size="pageSize"
          :total="totalDataNumber"
          layout="sizes,total, prev, pager, next"
          class="table-pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>

    </div>
    <!--弹出框-->
    <el-dialog :visible.sync="dialogFormVisiable" title="添加反馈意见">
      <el-form :rules="rules" :model="addForm" label-width="100px" >
        <el-form-item label="反馈意见名称" prop="opinionName">
          <el-input v-model="addForm.opinionName" placeholder="请输入反馈意见名称" size="mini"/>
        </el-form-item>
        <el-form-item label="描述">
          <el-input v-model="addForm.description" rows="3" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="addRoleCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="addRoleSubmit">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogModifyVisiable" title="修改反馈意见">
      <el-form :rules="rules" :model="addForm" label-width="100px">
        <el-form-item label="反馈意见名称" prop="opinionName">
          <el-input v-model="modifyForm.opinionName" placeholder="请输入反馈意见名称" size="mini"/>
        </el-form-item>
        <el-form-item label="描述">
          <el-input v-model="modifyForm.description" rows="3" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="updateRoleCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="updateRole">确 定</el-button>
      </div>
    </el-dialog>
    <!-- 点击删除按钮，删除确认框-->
    <el-dialog
      :visible.sync="deleteDialogVisible"
      title="提示"
      width="30%">
      <span>确定删除选择的反馈意见? </span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="deleteDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="handleClickDelete">确 定</el-button>
      </span>
    </el-dialog>

  </div>
</template>

<script>
import axios from 'axios'

export default {
  name: 'Index',
  data() {
    return {
      rules: {
        opinionName: [{ required: true, message: '请输入反馈意见名称', trigger: 'blur' }]
      },
      tag: '',
      allData: [], // 所有前端分页数据
      tableData: [], // 表格数据 仅展示当前页的数据
      pageNo: 1, // 当前页数
      totalDataNumber: 0, // 总记录数
      pageSize: 10,
      formLabelWidth: '100px', // 弹出框form宽
      dialogAuthVisiable: false,
      dialogFormVisiable: false,
      dialogModifyVisiable: false,
      deleteDialogVisible: false,
      addForm: {
        opinionName: '',
        description: ''
      },
      modifyForm: {
        id: '',
        opinionName: '',
        description: ''
      }
    }
  },
  created() {
    this.btn_search()
  },
  mounted() {
  },
  methods: {
    btn_search() {
      const vm = this
      axios.get(process.env.BASE_API + '/opinion/listpage', {
        params: {
          tag: this.tag,
          pageNo: this.pageNo,
          pageSize: this.pageSize
        }
      }).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
          vm.totalDataNumber = 0
          vm.allData = []
          vm.tableData = []
        } else {
          vm.totalDataNumber = parseInt(obj.data.totalElements)
          if (vm.totalDataNumber > 0) {
            vm.allData = obj.data.content
            vm.tableData = obj.data.content // obj.data.slice(0, vm.pageSize)
          } else {
            vm.allData = []
            vm.tableData = []
          }
        }
      }).catch(function(error) {
        alert(error)
      })
    },
    btn_clear() {
      this.tag = ''
      this.btn_search()
    },
    handleCurrentChange() {
      // this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
      this.btn_search()
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.btn_search()
      // this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
    },
    addRole() {
      this.dialogFormVisiable = true
    },
    addRoleCancel() {
      this.dialogFormVisiable = false
      this.clearForm()
    },
    clearForm() {
      this.addForm.opinionName = ''
      this.addForm.description = ''
    },
    addRoleSubmit() {
      const vm = this
      var params = new URLSearchParams()
      if (vm.addForm.opinionName === '') {
        this.$message.error('请输入反馈意见名称')
        return
      }
      params.append('opinionName', vm.addForm.opinionName)
      params.append('description', vm.addForm.description)
      axios.post(process.env.BASE_API + '/opinion/create', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.clearForm()
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.dialogFormVisiable = false
    },
    editRole(row) {
      this.dialogModifyVisiable = true
      this.modifyForm = row
    },
    updateRoleCancel() {
      this.dialogModifyVisiable = false
      this.modifyForm = ''
      this.btn_search()
    },
    updateRole() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.modifyForm.id)
      params.append('opinionName', vm.modifyForm.opinionName)
      params.append('description', vm.modifyForm.description)
      axios.post(process.env.BASE_API + '/opinion/update', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
        vm.modifyForm = ''
      }).catch(function(error) {
        alert(error)
      })
      this.dialogModifyVisiable = false
    },
    deleteRoleConfirm(row) {
      this.deleteRoleId = row.id
      this.deleteRoleName = row.opinionName
      this.deleteDialogVisible = true
    },
    handleClickDelete() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.deleteRoleId)
      axios.post(process.env.BASE_API + '/opinion/delete', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.deleteDialogVisible = false
    },
    setRoleAuth(id) {
    }
  }
}
</script>

<style scoped>
  .orderform {
    padding-top: 20px;
    padding-left: 10px;
    padding-right: 10px;
  }

  .mydiv {
    float: right;
    margin-right: 10px;
  }
</style>
